import * as server_main from '@minecraft/server'
import * as uicontroller from './ui_controller.js';
import * as entity_functions from './entity_functions.js';


function randomIntFromInterval(min, max) { // min and max included 
    return Math.floor(Math.random() * (max - min + 1) + min)
}
//INITIALIZES THE COMMAND POST
export async function splatter_ground(blockID, splat_size, originPoint, player){

    //let gaussian_extent = 4//How far should the splat start waning
   // let power = splat_size - gaussian_extent
    const block_positions_active = [] 
    player.tell("hmmm!")
    for (let x = 0; x < splat_size; x++)
    {
        for (let z = 0; z < splat_size; z++)
        {
            let random_powerX = math.round((splat_size * 0.5) - (Math.abs(x - (splat_size - x))) * 0.5)
            let random_powerZ = math.round((splat_size * 0.5) - (Math.abs(z - (splat_size - z))) * 0.5)

            let power_avg = math.round((random_powerX + random_powerZ) / 2)
            let total_power = (power_avg > 0) ? power_avg : 1
            player.tell(total_power.toString() + "WTFFF!")
            const rndInt = randomIntFromInterval(1, total_power)
            if (rndInt > (total_power * 0.5))
            {
                
                block_positions_active.push((x + originPoint[0]).toString() + ' 88 ' + (z + originPoint[0]).toString())
            }

        }
    }

    for (const pos of block_positions_active) {
        player.runCommandAsync('setblock ' + pos + ' ' + blockID.toString())
    }
}
//SETS THE COMMAND POS TO THE PLAYER AFER PLACING
export function update_commandpost(player){
    let command_entity = entity_functions.get_nearest_entityTAG_OBJECTIVE(player, 25, "command_post", "player_host", parseInt(player.id.toString().slice(5)))
    player.runCommandAsync('scoreboard players set @s command_post_id ' + command_entity.id.toString().slice(5))
    player.runCommandAsync('tag @s remove update_post')
}
//SETS THE COMMAND POS TO THE PLAYER AFER PLACING
export function destroy_commandpost(player){
    player.runCommandAsync('scoreboard players set @s command_post_id 0')
}



export async function open_commandpost(player, command_entity){
    player.runCommandAsync("tag @s remove command_ui")
    uicontroller.UI_COMMANDPOST(player, command_entity)
}

export function get_command_limit(entity){
    let size = entity_functions.get_entity_objective_score(entity, 'command_level')
    return Math.round(((size * 2) + ((size) % 2)) * 2.2)
}

export function get_command_pop(entity){
    let current_pop = entity_functions.get_entity_objective_score(entity, 'command_population')
    return current_pop
}


